unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs
  ,Synaser, Vcl.StdCtrls, synautil
  ,TP650
  ,Printers
  ,WinSpool
  , Math
  ;
type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    btQrSAT: TButton;
    btQrNFCe: TButton;
    btCod1d128: TButton;
    btGaveta: TButton;
    btGuilhotina: TButton;
    lbFeed: TLabel;
    Label4: TLabel;
    lbPulso: TLabel;
    Label2: TLabel;
    lbTampa: TLabel;
    Label6: TLabel;
    lbPapel: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    btLogo: TButton;
    edLogo: TEdit;
    GroupBox1: TGroupBox;
    cbbDriver: TComboBox;
    txtAlturaCod: TEdit;
    btCod1dUPCA: TButton;
    btCod1dEAN13: TButton;
    btCod1dEAN8: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    GroupBox4: TGroupBox;
    btTextoNormal: TButton;
    btTextoCondensado: TButton;
    btTextoNegrito: TButton;
    btTextoItalico: TButton;
    Button6: TButton;
    Button7: TButton;
    GroupBox5: TGroupBox;
    Button1: TButton;
    GroupBox6: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    CheckBox2: TCheckBox;
    Label3: TLabel;
    txtCompCod: TEdit;
    GroupBox7: TGroupBox;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox8: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    btStatus: TButton;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure btQrSATClick(Sender: TObject);
    procedure btCod1d128Click(Sender: TObject);
    procedure btQrNFCeClick(Sender: TObject);
    procedure btGavetaClick(Sender: TObject);
    procedure btGuilhotinaClick(Sender: TObject);
    procedure btTextoClick(Sender: TObject);
    procedure btStatusClick(Sender: TObject);
    procedure btLogoClick(Sender: TObject);
    procedure cbbDriverSelect(Sender: TObject);
    procedure btCod1dUPCAClick(Sender: TObject);
    procedure btCod1dEAN13Click(Sender: TObject);
    procedure btCod1dEAN8Click(Sender: TObject);
    procedure btTextoNormalClick(Sender: TObject);
    procedure btTextoCondensadoClick(Sender: TObject);
    procedure btTextoNegritoClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
    procedure FeedPaper;
    function FeedPaperCOM : AnsiString;
    procedure DebugCommandAnsi(func : AnsiString ; desc : AnsiString ; cmd : AnsiString);
    procedure DebugCommandTBy(func : AnsiString ; desc : AnsiString ; cmd : TBytes);
    function GetByte: byte;
    function VerificaStatus: boolean;
    procedure Cod128A();
    procedure Cod128ACupom();
    procedure Cod128C();
    procedure btQrSAT1();
    procedure btQrSAT2();
    procedure btQrNFCe1();
    procedure btQrNFCe2();
    procedure Exemplo01();
    procedure Exemplo02();
  public
    Serial : TBlockSerial ;
  end;

const
  CFailCount = 10;

var
  Form1: TForm1;

  fsSendBytesCount: Integer;
  fsSendBytesInterval: Integer;


  tp: TTP650;
  debug: boolean;
  ser: TBlockSerial;
  portaaberta : boolean;
  driverselecionado : String;

  HandleImp: THandle;
  CaracteresImpressos: DWORD;
  Documento: TDocInfo1;

  FuncaoAnsiString: AnsiString;

  ComandoAnsiString : AnsiString;
  ComandoTBytes : TBytes;

  DescricaoAnsiString: AnsiString;

  alturaCodAnsiString : AnsiString;
  larguraCodAnsiString : AnsiString;

  PrntRes : integer;
  opJustify : integer;
  limparMemo : boolean;

  justifyTBytes: TBytes;

  //CODEBAR


  AlturaTBytes : TBytes;
  LarguraTBytes : TBytes;
  formaEnvio : integer;

    portas : TStringList;
    F : TextFile;
  i : integer;
    conexao : Boolean;

implementation

{$R *.dfm}

function TBytesToAnsiString(cmd : Tbytes) : AnsiString;
var
  i : integer;
  ret : AnsiString;
begin
  {SetLength(cmd, Length(ret));
  Move(Pointer(ret)^, Pointer(cmd)^, Length(ret));}

  SetLength(ret, Length(cmd));
  Move(Pointer(cmd)^, Pointer(ret)^, Length(cmd));

  Result := ret;
end;

function DecToBin(Valor: Integer) : String;
var
  Binario: String;
begin
  while (valor >= 1) do
  begin
    Binario := IntToStr(valor mod 2) + Binario;
    Valor := (Valor div 2);
  end;

  Result := Binario;
end;

function charToHex(cmd : AnsiString): AnsiString;
var
  i : integer;
  res : AnsiString;

begin
  i := 1;
  while(i <= Length(cmd)) do
  begin
    res := res + StrToHex(cmd[i])+' ';
    i := i+1;
  end;
     result := res + '0A';

end;


function format(cmd : AnsiString) : AnsiString;
var
  i : integer;
  res : AnsiString;
  flag : integer;
begin
  if(cmd <> '') then
  begin
    i :=0;
    flag :=0;

    cmd := StrToHex(cmd);
    while( i <= Length(cmd)) do
    begin
      if(((i mod 2) = 0) and (flag = 0)) then
      begin
         res := res + ' ';
         flag :=1;
      end
      else
      begin
        flag :=0;
        res := res + cmd[i+1];
        i := i+ 1;
      end;

    end;
    result := UpperCase(res);
  end
  else
    result := cmd;
end;
function HexToStr(H: String): String;
var I : Integer;
begin
  Result:= '';
  for I := 1 to length (H) div 2 do
    Result:= Result+Char(StrToInt('$'+Copy(H,(I-1)*2+1,2)));
end;



function HexToInt(Hexadecimal : String) : AnsiString;
var
  int : integer;
  i : integer;
  aux : AnsiString;
begin
  if(HexaDecimal <> '') then
  begin

  i := 2;

  while( i< Length(Hexadecimal)) do
  begin

    int := StrToInt('$' + copy(Hexadecimal,i,2));
    aux := aux +' '+ IntToStr(int);
    i := i + 3;
  end;
  Result := aux;
  end
  else
      Result := Hexadecimal;
end;




function TForm1.VerificaStatus: boolean;
var
  C : String;
  cmd : String;
  b : byte;
  binario : string;
  s1, s2, s3, s4 : AnsiString;
begin;
  justifyTBytes := tp.justify(opJustify);
  DescricaoAnsiString := 'Lendo Status...';
  if(limparMemo = true) then
    Memo1.Clear;

  DebugCommandAnsi('DLE EOT n', 'Status Pulso/Gaveta', tp.getStatusDrawer);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  DebugCommandAnsi('DLE EOT n', 'Status Boto Feed', tp.getStatusBotaoFeed);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  DebugCommandAnsi('DLE EOT n', 'Status Tampa', tp.getStatusTampa);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  DebugCommandAnsi('DLE EOT n', 'Status Papel', tp.getStatusPapel);

  if(cbbDriver.Text <> '') then
    begin
      try
        AssignFile(F,cbbDriver.Text);
        Rewrite(F);

        Writeln(F,TBytesToAnsiString(justifyTBytes));
        Writeln(F,DescricaoAnsiString);


        CloseFile(F);
        conexao := True;
       except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
          conexao := False;
       end;
    end;
  if(conexao = True) then
  begin
      Serial := TBlockSerial.Create;
  Serial.Connect(cbbDriver.Text);

  //  n == 1
  Serial.Purge;
  Serial.SendString(tp.getStatusDrawer);
  b := GetByte;
  binario := DecToBin(b);
	if (tp.statusDrawerOn(b)) then
		s1 := 'Fechada/Sem'
	else
    s1 := 'Aberta';
  lbPulso.Caption := s1;


  //  n == 2
  Serial.Purge;
  Serial.SendString(tp.getStatusBotaoFeed);
  b := GetByte;
	if (tp.statusBotaoFeedPressed(b)) then
		s2 := 'ON'
	else
    s2 := 'OFF';
  lbFeed.Caption := s2;


  //  n ==  2
  Serial.Purge;
  Serial.SendString(tp.getStatusTampa);
  b := GetByte;

	if (tp.statusTampa(b)) then
		s3 := 'Fechada'
	else
    s3 := 'Aberta';
  lbTampa.Caption := s3;

  if(b<>54) then
  begin
    //  n == 4
    Serial.Purge;
    Serial.SendString(tp.getStatusPapel);
    b := GetByte;

	  if (tp.statusPapel(b)) then
		  s4 := 'Com Papel'
	  else
       s4 := 'Sem Papel';
  end
  else
     s4 := '-';
  lbPapel.Caption := s4;

  Serial.Free;

  if((cbbDriver.Text <> '') and (conexao = True)) then
    begin

        AssignFile(F,cbbDriver.Text);
        Rewrite(F);
        DescricaoAnsiString := 'Pulso/Gaveta: ';
        Write(F,DescricaoAnsiString);
        Writeln(F,s1);
        DescricaoAnsiString := 'Botao Feed: ';
        Write(F,DescricaoAnsiString);
        Writeln(F,s2);
        DescricaoAnsiString := 'Tampa: ';
        Write(F,DescricaoAnsiString);
        Writeln(F,s3);
        DescricaoAnsiString := 'Papel: ';
        Write(F,DescricaoAnsiString);
        Writeln(F,s4);
        DescricaoAnsiString := #10+#10+#10+#10+#10+#10+#10+#10+#10+#10;
        Writeln(F,DescricaoAnsiString);
        CloseFile(F);

    end;


  end;
  end
  else
  begin
     Result := False;
  end;


end;

function TForm1.GetByte: byte;
var
  b : byte;
  h : AnsiString;
  c  : char;
begin;
  b := Serial.RecvByte(500);
  Result:= b;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  opJustify := 48;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  opJustify := 49;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  opJustify := 50;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
  GroupBox1.Caption := 'Selecione a porta';
  cbbDriver.Text :='';
  formaEnvio :=0;
  cbbDriver.Items := portas;
  btStatus.Visible := True;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
begin
  GroupBox1.Caption := 'Selecione a impressora';
  cbbDriver.Text :='';
  formaEnvio :=1;
  cbbDriver.Items := Printer.Printers;
  btStatus.Visible := False;
end;

procedure TForm1.FeedPaper;
begin
  ComandoAnsiString :=#10+#10+#10+#10+#10+#10+#10+#10+#10+#10+#10+#10+#10;
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);
end;

function TForm1.FeedPaperCOM : AnsiString;
begin

  Result :=#10+#10+#10+#10+#10+#10+#10+#10+#10+#10+#10+#10+#10;

end;


procedure TForm1.DebugCommandAnsi(func : AnsiString; desc : AnsiString; cmd : AnsiString);
begin

   Memo1.Lines.Add('');
   Memo1.Lines.Add('Funo - '+ func);
   Memo1.Lines.Add('Descrio - '+ desc);
   Memo1.Lines.Add('Codigo Hexa   : '+ format(cmd));
   Memo1.Lines.Add('');
   Memo1.Lines.Add('Codigo Decimal: '+ HexToInt(format(cmd)));
   {Memo1.Lines.Add('Codigo ASCII: '+ HexToStr(format(cmd))); }
   Memo1.Lines.Add('');
end;



procedure TForm1.DebugCommandTBy(func: AnsiString ; desc : AnsiString; cmd : TBytes);
var
  comando : AnsiString;
begin
   comando := TBytesToAnsiString(cmd);
   Memo1.Lines.Add('');
   Memo1.Lines.Add('Funo - '+ func);
   Memo1.Lines.Add('Descrio - '+ desc);
   Memo1.Lines.Add('Codigo Hexa   : ' + format(comando));
   Memo1.Lines.Add('');
   Memo1.Lines.Add('Codigo Decimal: '+ HexToInt(format(comando)));

   {Memo1.Lines.Add('Codigo ASCII: '+ HexToStr(format(cmd))); }
   Memo1.Lines.Add('');

end;


procedure TForm1.btCod1dEAN13Click(Sender: TObject);
begin
  justifyTBytes := tp.justify(opJustify);

  LarguraTBytes := tp.setHeightCode(StrToInt(txtAlturaCod.Text));
  AlturaTBytes := tp.setWidthCode(StrToInt(txtCompCod.Text));

  FuncaoAnsiString := 'GS k m n d1...dn';

  DescricaoAnsiString := 'Exemplo EAN13. Altura: ' + txtAlturaCod.Text;
  ComandoAnsiString := tp.codEAN13('123456789012');

   if(limparMemo = true) then
    Memo1.Clear;

  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandTBy('GS h n', 'Seleo de altura do codigo', AlturaTBytes);
  DebugCommandTBy('GS w n', 'Seleo de comprimento do codigo', LarguraTBytes);
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,TBytesToAnsiString(alturaTBytes));
      Writeln(F,TBytesToAnsiString(larguraTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F, ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;


  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @AlturaTBytes[0], Length(AlturaTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @LarguraTBytes[0], Length(LarguraTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);


  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;
end;

procedure TForm1.btCod1dEAN8Click(Sender: TObject);
begin
  justifyTBytes := tp.justify(opJustify);

  LarguraTBytes := tp.setHeightCode(StrToInt(txtAlturaCod.Text));
  AlturaTBytes := tp.setWidthCode(StrToInt(txtCompCod.Text));

  FuncaoAnsiString := 'GS k m n d1...dn';

  DescricaoAnsiString := 'Exemplo EAN8. Altura: ' + txtAlturaCod.Text;

  ComandoAnsiString := tp.codEAN8('1234567');
  if(limparMemo = true) then
    Memo1.Clear;
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandTBy('GS h n', 'Seleo de altura do codigo', AlturaTBytes);
  DebugCommandTBy('GS w n', 'Seleo de comprimento do codigo', LarguraTBytes);
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,TBytesToAnsiString(alturaTBytes));
      Writeln(F,TBytesToAnsiString(larguraTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F, ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);
  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @AlturaTBytes[0], Length(AlturaTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @LarguraTBytes[0], Length(LarguraTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);

  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);


  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;


end;

procedure TForm1.btCod1dUPCAClick(Sender: TObject);
begin
  justifyTBytes := tp.justify(opJustify);

  LarguraTBytes := tp.setHeightCode(StrToInt(txtAlturaCod.Text));
  AlturaTBytes := tp.setWidthCode(StrToInt(txtCompCod.Text));

  FuncaoAnsiString := 'GS k m n d1...dn';
  DescricaoAnsiString := 'Exemplo UPCA. Alt.: ' + txtAlturaCod.Text +' Comp.: '+txtCompCod.Text;

  ComandoAnsiString := tp.codUPCA('12345678901');
  if(limparMemo = true) then
    Memo1.Clear;

  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandTBy('GS h n', 'Seleo de altura do codigo', AlturaTBytes);
  DebugCommandTBy('GS w n', 'Seleo de comprimento do codigo', LarguraTBytes);
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,TBytesToAnsiString(alturaTBytes));
      Writeln(F,TBytesToAnsiString(larguraTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F, ComandoAnsiString);
      Write(F,feedPaperCom());


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin

  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @AlturaTBytes[0], Length(AlturaTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @LarguraTBytes[0], Length(LarguraTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);

  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.Cod128A();
begin
  justifyTBytes := tp.justify(opJustify);

  LarguraTBytes := tp.setHeightCode(StrToInt(txtAlturaCod.Text));
  AlturaTBytes := tp.setWidthCode(StrToInt(txtCompCod.Text));

  FuncaoAnsiString := 'GS k m n d1...dn';
  DescricaoAnsiString := 'Exemplo CODE128B linha simples Alt.: ' + txtAlturaCod.Text +' Comp.: '+txtCompCod.Text+ #10;
  ComandoAnsiString := tp.cod128B('0123456789');

  if(limparMemo = true) then
    Memo1.Clear;


  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandTBy('GS h n', 'Seleo de altura do codigo', alturaTBytes);
  DebugCommandTBy('GS w n', 'Seleo de comprimento do codigo', larguraTBytes);
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,TBytesToAnsiString(alturaTBytes));
      Writeln(F,TBytesToAnsiString(larguraTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F, ComandoAnsiString);

      CloseFile(F);
      conexao:=True;
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
          conexao:=False;
       end;
    end;
    end;
  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin

  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @AlturaTBytes[0], Length(AlturaTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, @LarguraTBytes[0], Length(LarguraTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);


  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);


  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);
  end;
  end;

end;

procedure TForm1.Cod128ACupom();
var
  tam: integer;
begin

  DescricaoAnsiString := 'Exemplo CODE128B linha dupla Alt.: ' + txtAlturaCod.Text +' Comp.: '+txtCompCod.Text+ #10;
  ComandoAnsiString := tp.cod128B('02019000000000000000099000000000000000020190');

  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  if(formaEnvio = 0) then
    begin
      if((cbbDriver.Text <> '') and (conexao = True)) then
        begin

        AssignFile(F,cbbDriver.Text);
        Rewrite(F);

        Writeln(F,TBytesToAnsiString(justifyTBytes));
        Writeln(F,DescricaoAnsiString);
        Writeln(F, ComandoAnsiString);

        CloseFile(F);


      end;
    end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin

  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);

  end;
  end;

end;


procedure TForm1.Cod128C();
var
  tam: integer;
  s : AnsiString;
  i : integer;
  len : integer;
  aux : integer;
begin
  DescricaoAnsiString := 'Exemplo CODE128C. Altura: ' + txtAlturaCod.Text + #10;
  ComandoTBytes := tp.cod128C('01234567890123456789012345678901234567891234');



  DebugCommandTBy(FuncaoAnsiString, DescricaoAnsiString, ComandoTBytes);

  if(formaEnvio = 0) then
  begin
    if((cbbDriver.Text <> '') and (conexao = True)) then
      begin
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,DescricaoAnsiString);
      Writeln(F,TBytesToAnsiString(ComandoTBytes));
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin


  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);


  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, @ComandoTBytes[0], Length(ComandoTBytes), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);



  end;
  end;

end;

procedure TForm1.btCod1d128Click(Sender: TObject);
begin
  Cod128A();
  Cod128ACupom();
  Cod128C();


end;

procedure TForm1.btGavetaClick(Sender: TObject);
begin
  justifyTBytes := tp.justify(opJustify);
  FuncaoAnsiString := 'DLE DC4 n m t';
  DescricaoAnsiString := 'Exemplo Abre Gaveta' + #10;
  ComandoAnsiString := tp.abreGaveta(0,4);
  Memo1.Clear;
   DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
   if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin

  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);


  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.btGuilhotinaClick(Sender: TObject);
var
  pulaLinha : AnsiString;
begin
  pulaLinha := #10+#10+#10+#10+#10;
  justifyTBytes := tp.justify(opJustify);

  FuncaoAnsiString := 'ESC i (for cut)';
  DescricaoAnsiString := 'Exemplo Corte Papel';
  ComandoTBytes:= tp.cortePapel();
  Memo1.Clear;
  DebugCommandTBy(FuncaoAnsiString, DescricaoAnsiString, ComandoTBytes);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,pulaLinha);
      Writeln(F,TBytesToAnsiString(ComandoTBytes));
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);



  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(pulaLinha), Length(pulaLinha), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoTBytes), Length(ComandoTBytes), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.btLogoClick(Sender: TObject);
begin

  justifyTBytes := tp.justify(opJustify);
  FuncaoAnsiString := 'FS p n m';
  DescricaoAnsiString := 'Exemplo Imprimir Logo' + #10;
  ComandoAnsiString := tp.logoNV(strtoint(edLogo.Text));
  Memo1.Clear;
   DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin

  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin

  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);



  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;
end;

procedure TForm1.btQrNFCeClick(Sender: TObject);
begin
    btQrNFCe1();
    //btQrNFCe2();
end;

procedure TForm1.btQrNFCe1();
begin

  justifyTBytes := tp.justify(opJustify);
  FuncaoAnsiString := 'GS ( k pL pH cn fn';
  DescricaoAnsiString := 'Exemplo QRCode NFCe';

  ComandoAnsiString := tp.qrcode(4, 'http://www.sefaz.mt.gov.br/nfce/consultanfce?chNFe=51'+
                          '131003460900000290650010000000031000000031&nVersao=10'+
                          '0&tpAmb=2&cDest=02801244147&dhEmi=323031332D31302D323'+
                          '45431363A32313A30332D30333A3030&vNF=1,00&vICMS=0,00&d'+
                          'igVal=78764D34764E2B48586A735657516F653474415A5478555'+
                          '47764383D&cIdToken=000001&cHashQRCode=7AF4285DA2D1813'+
                          '3BEF9F9370AD4A185B2527AFB') + #10;

  if(limparMemo = true) then
    Memo1.Clear;

  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Write(F,ComandoAnsiString);
      Write(F,feedPaperCom());

      CloseFile(F);
      conexao:=True;
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
          conexao:=False;
       end;
    end;
    end;

  end
  else
  begin

  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
    DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
    Documento.pDocName := PChar('Minha impresso');
    Documento.pOutputFile := nil;
    Documento.pDataType := 'RAW';

    StartDocPrinter(HandleImp, 1, @Documento);
    StartPagePrinter(HandleImp);
    WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
    WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);

    WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);
    FeedPaper();

    EndPagePrinter(HandleImp);
    EndDocPrinter(HandleImp);

    ClosePrinter(HandleImp);
  end;
  end;

end;

procedure TForm1.btQrNFCe2();
var
  textoSimples : AnsiString;
  cmd : TBytes;
begin

  justifyTBytes := tp.justify(opJustify);
  FuncaoAnsiString := 'GS ( k pL pH cn fn';
  DescricaoAnsiString := 'Exemplo QRCode NFCe ModePage ON'+ #10;

  ComandoAnsiString := tp.qrcode(4, 'http://www.sefaz.mt.gov.br/nfce/consultanfce?chNFe=51'+
                          '131003460900000290650010000000031000000031&nVersao=10'+
                          '0&tpAmb=2&cDest=02801244147&dhEmi=323031332D31302D323'+
                          '45431363A32313A30332D30333A3030&vNF=1,00&vICMS=0,00&d'+
                          'igVal=78764D34764E2B48586A735657516F653474415A5478555'+
                          '47764383D&cIdToken=000001&cHashQRCode=7AF4285DA2D1813'+
                          '3BEF9F9370AD4A185B2527AFB');


  DebugCommandTBy('ESC L', 'Selecionar Modo Pagina', tp.ligaModoPagina);
  DebugCommandTBy('ESC T n', 'Selecionar direcao de impressao', tp.ajustarDirecao);
  DebugCommandTBy('ESC W xL xH yL yH dxL dxH dyL dyH', 'Definir area de impressao', tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2));
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  DebugCommandTBy('ESC FF', 'Imprimir no Modo Pagina', tp.printMemory);
  DebugCommandTBy('ESC S', 'Selecionar Modo Padrao', tp.desligaModoPagina);

  if(formaEnvio = 0) then
  begin
    if((cbbDriver.Text <> '') and (conexao = True)) then
    begin
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Write(F,DescricaoAnsiString);
      Write(F,TBytesToAnsiString(tp.ligaModoPagina));
      Write(F,TBytesToAnsiString(tp.ajustarDirecao));
      Write(F,TBytesToAnsiString(tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2)));
      textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(tp.ajustarArea(35, 1, 0, 0, 69, 1, 40, 2)));
      textoSimples := tp.textoCondensado('Consumidor:')+#10+ tp.textoCondensado('CONSUMIDOR NAO IDENTIFICADO');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('No.Serie do MFE:000.0007.776');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('01/01/2019 - 16:14:37')+#10;
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Consulte o QR Code pelo')+#10+tp.textoCondensado('aplicativo, disponivel na')+#10+ tp.textoCondensado('AppStore e PlayStore')+ #10;
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(tp.printMemory));
      Write(F,TBytesToAnsiString(tp.desligaModoPagina));
      Writeln(F,FeedPaperCOM);

      CloseFile(F);
    end;

  end
  else
  begin

  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
    DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString));
    Documento.pDocName := PChar('Minha impresso');
    Documento.pOutputFile := nil;
    Documento.pDataType := 'RAW';

    StartDocPrinter(HandleImp, 1, @Documento);
    StartPagePrinter(HandleImp);

    WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
      cmd := tp.ligaModoPagina();
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     cmd := tp.ajustarDirecao();
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     cmd:=  tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2);
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     //cmd := tp.printMemory;
     //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     cmd:=  tp.ajustarArea(35, 1, 0, 0, 69, 1, 40, 2);
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     textoSimples := tp.textoCondensado('Consumidor:')+#10+ tp.textoCondensado('CONSUMIDOR NAO IDENTIFICADO')+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     textoSimples := tp.textoCondensado('No.Serie do SAT:000.0007.776')+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     textoSimples := tp.textoCondensado('01/01/2019 - 16:14:37')+#10+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     textoSimples := tp.textoCondensado('Consulte o QR Code pelo')+#10+tp.textoCondensado('aplicativo, disponivel na AppStore e PlayStore')+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);

     cmd := tp.printMemory;
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);

     cmd := tp.desligaModoPagina();
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);

     FeedPaper();

    EndPagePrinter(HandleImp);
    EndDocPrinter(HandleImp);

    ClosePrinter(HandleImp);
  end;
  end;

end;






procedure TForm1.btQrSATClick(Sender: TObject);
var
  teste : TStrings;

begin
  btQrSAT1();
  //btQrSAT2();
end;

procedure TForm1.btQrSAT1();
var
  texto : AnsiString;
  texto2 : AnsiString;
  modePageOn: TBytes;
  modePageOff: TBytes;
  impMemoria: TBytes;
  direcao: TBytes;
  area: TBytes;
  esp : AnsiString;


begin

  justifyTBytes := tp.justify(opJustify);

  FuncaoAnsiString := 'GS ( k pL pH cn fn';
  DescricaoAnsiString := AnsiString ('Exemplo QRCode SAT');
  ComandoAnsiString := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==') + #10;

  if(limparMemo = true) then
    Memo1.Clear;

  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');

  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Write(F,ComandoAnsiString);
      Write(F,feedPaperCom());
      CloseFile(F);
      conexao := True;
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
          conexao := False;
       end;
    end;
    end;

  end
  else
  begin

  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
    //Cria um novo Documento
    DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
    Documento.pDocName := PChar('Minha impresso');
    Documento.pOutputFile := nil;
    Documento.pDataType := 'RAW';

    //Inicia um novo documento no Spool do Windows
    StartDocPrinter(HandleImp, 1, @Documento);
    //Apenas notifica o Windows que uma nova pgina comear.
    //Nenhum controle  aplicado a impressora.
    StartPagePrinter(HandleImp);

    WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
    WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
    WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

    //WritePrinter(HandleImp, PAnsiChar(esp), Length(esp), CaracteresImpressos);

    FeedPaper();
    EndPagePrinter(HandleImp);
    EndDocPrinter(HandleImp);

    ClosePrinter(HandleImp);
  end;
  end;

end;



procedure TForm1.btQrSAT2();
var
  texto : AnsiString;
  texto2 : AnsiString;

  justify: TBytes;
  textoSimples : AnsiString;
  cmd : TBytes;




begin
  justify := tp.justify(opJustify);

  DescricaoAnsiString := AnsiString ('Exemplo QRCode SAT ModePage ON'+ #10);
  texto := tp.textoNegrito('Consumidor:')+ #10 + tp.printMode('CONSUMIDOR NAO IDENTIFICADO','0') + #10 + tp.textoNegrito('SAT No.') + tp.printMode('000.007.776','0') + #10 + tp.printMode('19/04/2016 - 16:14:37', '0') + #10 +tp.printMode('Consulte o QR Code pelo' + #10 + 'aplicativo "De olho na nota" '+ #10 + 'disponivel na AppStore(Apple)' + #10 +'e PlayStore(Android).','0');

  ComandoAnsiString := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');

  //Memo1.Clear;
  DebugCommandTBy('ESC L', 'Selecionar Modo Pagina', tp.ligaModoPagina);
  DebugCommandTBy('ESC T n', 'Selecionar direcao de impressao', tp.ajustarDirecao);
  DebugCommandTBy('ESC W xL xH yL yH dxL dxH dyL dyH', 'Definir area de impressao', tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2));
  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  DebugCommandTBy('ESC FF', 'Imprimir no Modo Pagina', tp.printMemory);
  DebugCommandTBy('ESC S', 'Selecionar Modo Padrao', tp.desligaModoPagina);
  if(formaEnvio = 0) then
  begin
    if((cbbDriver.Text <> '') and (conexao = True)) then
    begin
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Write(F,DescricaoAnsiString);
      Write(F,TBytesToAnsiString(tp.ligaModoPagina));
      Write(F,TBytesToAnsiString(tp.ajustarDirecao));
      Write(F,TBytesToAnsiString(tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2)));
      textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(tp.ajustarArea(35, 1, 0, 0, 69, 1, 40, 2)));
      textoSimples := tp.textoCondensado('Consumidor:')+#10+ tp.textoCondensado('CONSUMIDOR NAO IDENTIFICADO');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('No.Serie do SAT:000.0007.776');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('01/01/2019 - 16:14:37')+#10;
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Consulte o QR Code pelo')+#10+tp.textoCondensado('aplicativo "De olho na nota",')+#10+ tp.textoCondensado('disponivel na AppStore (Apple)')+#10+tp.textoCondensado('e PlayStore (Android)');
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(tp.printMemory));
      Write(F,TBytesToAnsiString(tp.desligaModoPagina));
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
    end;

  end
  else
  begin

  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
    //Cria um novo Documento
    Documento.pDocName := PChar('Minha impresso');
    Documento.pOutputFile := nil;
    Documento.pDataType := 'RAW';

    //Inicia um novo documento no Spool do Windows
    StartDocPrinter(HandleImp, 1, @Documento);
    //Apenas notifica o Windows que uma nova pgina comear.
    //Nenhum controle  aplicado a impressora.
    StartPagePrinter(HandleImp);
    WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
     cmd := tp.ligaModoPagina();
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     cmd := tp.ajustarDirecao();
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     cmd:=  tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2);
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     //cmd := tp.printMemory;
     //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     cmd:=  tp.ajustarArea(35, 1, 0, 0, 69, 1, 40, 2);
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
     textoSimples := tp.textoCondensado('Consumidor:')+#10+ tp.textoCondensado('CONSUMIDOR NAO IDENTIFICADO')+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     textoSimples := tp.textoCondensado('No.Serie do SAT:000.0007.776')+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     textoSimples := tp.textoCondensado('01/01/2019 - 16:14:37')+#10+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
     textoSimples := tp.textoCondensado('Consulte o QR Code pelo')+#10+tp.textoCondensado('aplicativo "De olho na nota",')+#10+ tp.textoCondensado('disponivel na AppStore (Apple)')+#10+tp.textoCondensado('e PlayStore (Android)')+#10;
     WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);





     cmd := tp.printMemory;
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);

     cmd := tp.desligaModoPagina();
     WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);

     FeedPaper();


    EndPagePrinter(HandleImp);
    EndDocPrinter(HandleImp);

    ClosePrinter(HandleImp);
  end;
  end;

end;


procedure TForm1.btStatusClick(Sender: TObject);
begin
  if (VerificaStatus) then
    ShowMessage('Status lido com sucesso!')


end;

procedure TForm1.btTextoClick(Sender: TObject);
begin
  {DebugCommand('Impressao de texto:');     }
  //SendString(tp.textoNegrito('Exemplo texto em negrito')+#10);
  //SendString(tp.textoCondensado('Exemplo texto condensado' + #10));
  FeedPaper;
end;

procedure TForm1.btTextoCondensadoClick(Sender: TObject);

begin
  justifyTBytes := tp.justify(opJustify);

  FuncaoAnsiString := 'ESC ! n';

  DescricaoAnsiString := 'Impressao de texto Condensado';
  ComandoAnsiString := tp.textoCondensado('Exemplo texto condensado');
  if(limparMemo = true) then
    Memo1.Clear;
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);

  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  textoSimples : AnsiString;
  cmd : TBytes;
begin
  LarguraTBytes := tp.setHeightCode(StrToInt(txtAlturaCod.Text));
  AlturaTBytes := tp.setWidthCode(StrToInt(txtCompCod.Text));

  textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');

  FuncaoAnsiString := '-';
  DescricaoAnsiString := 'Cupom Fiscal: ';
  if(limparMemo = true) then
    Memo1.Clear;

  //DebugCommandTBy('ESC L', 'Selecionar Modo Pagina', tp.ligaModoPagina);
  //DebugCommandTBy('ESC T n', 'Selecionar direcao de impressao', tp.ajustarDirecao);
  //DebugCommandTBy('ESC W xL xH yL yH dxL dxH dyL dyH', 'Definir area de impressao', tp.ajustarArea(0, 1, 0, 0, 69, 1, 40, 1));
  DebugCommandAnsi('ESC ! n', 'Impressao de texto Negrito', tp.textoNegrito('Jetway Informatica'));
  DebugCommandAnsi('ESC ! n', 'Impressao de texto Normal', tp.textoNegrito('R. Mal. Floriano Peixoto, 166'));
  //DebugCommandTBy('ESC FF', 'Imprimir no Modo Pagina', tp.printMemory);
  //DebugCommandTBy('ESC S', 'Selecionar Modo Padrao', tp.desligaModoPagina);
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', tp.justify(49));


  DescricaoAnsiString := 'Exemplo CODE128C. Altura: ' + txtAlturaCod.Text + #10;
  ComandoTBytes := tp.cod128C('01234567890123456789012345678901234567891234');
  DebugCommandTBy('GS k m n d1...dn', DescricaoAnsiString, ComandoTBytes);



  DebugCommandAnsi('GS ( k pL pH cn fn', 'Exemplo QRCode SAT', textoSimples);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
    try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);
      //Write(F,TBytesToAnsiString(tp.ligaModoPagina));
      //Write(F,TBytesToAnsiString(tp.ajustarDirecao));
      //Write(F,TBytesToAnsiString(tp.ajustarArea(0, 0, 0, 0, 69, 2, 80, 2)));
      //Write(F, tp.logoNV(strtoint(edLogo.Text)));
      //Write(F,TBytesToAnsiString(tp.ajustarArea(0, 1, 0, 0, 69, 1, 40, 1)));
      Write(F,TBytesToAnsiString(tp.justify(50)));
      textoSimples := tp.textoNegrito('Jetway Informatica');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('R. Mal. Floriano Peixoto, 166');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Vila Marcondes, Pres. Prudente - SP')+#10+#10;
      Writeln(F,textoSimples);
      //Write(F,TBytesToAnsiString(tp.printMemory));
      //Write(F,TBytesToAnsiString(tp.desligaModoPagina));
      Write(F,TBytesToAnsiString(tp.justify(49)));
      textoSimples := tp.textoCondensado('CNPJ: 08.723.218/0001-86 IE: 562.377.111.111');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Extrato No ') + tp.textoNegrito('001328 ')+ tp.textoCondensado('do CUPOM FISCAL ELETRONICO - SAT');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('#  COD   DESC   QTD   UN   VL   UN R$   (VL TR R$)*   VL ITEM R$');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('---------------------------------------------------------------');
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(tp.justify(48)));
      textoSimples := tp.textoCondensado('001 387614 Micro i3 4GbRAM               1 UN x 600,00    600,00');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('001 387615 Micro i5 8GbRAM               2 UN x 750,00   1400,00') + #10;
      Writeln(F,textoSimples);
      textoSimples := tp.printMode('TOTAL R$                 2000,00','1')+#10;
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Cartao de Debito                                  2000,00')+#10;
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('ICMS a ser recolhido conforme LC 123/2006 - Simples Nacional');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('01.01.01.01 - Consulte o QRCode deste extrato atraves do App DeOlhoNaNota')+#10;
      Writeln(F,textoSimples);
      textoSimples := 'OBSERVACOES DO CONTRIBUINTE';
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Trib aprox: R$ x,xx Federais, x,xx Estaduais e x,xx Municipais.');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Fonte: IBPT')+#10;
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('*Valor aproximado dos tributos do item');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Valor aproximado dos tributos deste cupom');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Conforme Lei Fed. 12/741/2012                             R$0,00');
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(tp.justify(49)));
      textoSimples := tp.textoCondensado('---------------------------------------------------------------');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('3516 0411 3280 7000 0190 5900 0007 7760 0132 8089 3192');
      Writeln(F,textoSimples);
      Write(F,TBytesToAnsiString(alturaTBytes));
      Write(F,TBytesToAnsiString(larguraTBytes));
      Write(F,TBytesToAnsiString(tp.cod128C('35160411328070000190590000077760013280893192')));
      //Write(F,TBytesToAnsiString(tp.ligaModoPagina));
      //Write(F,TBytesToAnsiString(tp.ajustarDirecao));
      //Write(F,TBytesToAnsiString(tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2)));
      textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');
      Writeln(F,textoSimples);
      //Write(F,TBytesToAnsiString(tp.ajustarArea(35, 1, 0, 0, 69, 1, 40, 2)));
      textoSimples := tp.textoCondensado('Consumidor: CONSUMIDOR NAO IDENTIFICADO') +#10+ tp.textoCondensado('No.Serie do SAT:000.0007.776 | 01/01/2019 - 16:14:37');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Consulte o QR Code pelo aplicativo "De olho na nota",')+#10+ tp.textoCondensado('disponivel na AppStore (Apple)e PlayStore (Android)');
      Writeln(F,textoSimples);
      //Write(F,TBytesToAnsiString(tp.printMemory));
      //Write(F,TBytesToAnsiString(tp.desligaModoPagina));
      Write(F,TBytesToAnsiString(tp.justify(49)));
      textoSimples := tp.textoCondensado('---------------------------------------------------------------');
      Writeln(F,textoSimples);
      textoSimples := tp.textoCondensado('Projeto Tanca - www.tanca.com.br');
      Writeln(F,textoSimples);
      textoSimples := #10+#10+#10+#10+#10+#10;
      Write(F,textoSimples);

      Writeln(F,TBytesToAnsiString(tp.cortePapel));


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);
  StartPagePrinter(HandleImp);


          //cmd := tp.ligaModoPagina();
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          //cmd := tp.ajustarDirecao();
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
         // cmd:=  tp.ajustarArea(0, 1, 0, 0, 69, 1, 40, 1);
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          cmd := tp.justify(50);
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          textoSimples := tp.textoNegrito('Jetway Informatica' + #10);
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('R. Mal. Floriano Peixoto, 166'+ #10);
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Vila Marcondes, Pres. Prudente - SP')+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          cmd := tp.printMemory;
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          cmd := tp.desligaModoPagina();
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          cmd := tp.justify(49);
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          textoSimples := tp.textoCondensado('CNPJ: 08.723.218/0001-86 IE: 562.377.111.111') + #10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Extrato No ')+ tp.textoNegrito('001328 ')+ tp.textoCondensado('do CUPOM FISCAL ELETRONICO - SAT') + #10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('#  COD   DESC   QTD   UN   VL   UN R$   (VL TR R$)*   VL ITEM R$') + #10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('---------------------------------------------------------------') + #10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          cmd := tp.justify(48);
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          textoSimples := tp.textoCondensado('001 387614 Micro i3 4GbRAM               1 UN x 600,00    600,00') + #10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('001 387615 Micro i5 8GbRAM               2 UN x 750,00   1400,00') + #10 +#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.printMode('TOTAL R$                 2000,00','1')+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Cartao de Debito                                  2000,00')+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('ICMS a ser recolhido conforme LC 123/2006 - Simples Nacional')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('01.01.01.01 - Consulte o QRCode deste extrato atraves do App DeOlhoNaNota')+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'OBSERVACOES DO CONTRIBUINTE'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Trib aprox: R$ x,xx Federais, x,xx Estaduais e x,xx Municipais.')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Fonte: IBPT')+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('*Valor aproximado dos tributos do item')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Valor aproximado dos tributos deste cupom')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Conforme Lei Fed. 12/741/2012                             R$0,00')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);

          cmd := tp.justify(49);
          WritePrinter(HandleImp, cmd, Length(cmd), CaracteresImpressos);
          textoSimples := tp.textoCondensado('---------------------------------------------------------------'+#10);
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('3516 0411 3280 7000 0190 5900 0007 7760 0132 8089 3192')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          WritePrinter(HandleImp, @AlturaTBytes[0], Length(AlturaTBytes), CaracteresImpressos);
          WritePrinter(HandleImp, @LarguraTBytes[0], Length(LarguraTBytes), CaracteresImpressos);
          cmd := tp.cod128C('35160411328070000190590000077760013280893192');
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          //textoSimples := #10;
          //WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          //cmd := tp.ligaModoPagina();
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          //cmd := tp.ajustarDirecao();
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          //cmd:=  tp.ajustarArea(0, 0, 0, 0, 69, 1, 40, 2);
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          textoSimples := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          //cmd := tp.printMemory;
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          //cmd:=  tp.ajustarArea(35, 1, 0, 0, 69, 1, 40, 2);
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Consumidor: CONSUMIDOR NAO IDENTIFICADO')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('No.Serie do SAT:000.0007.776 | 01/01/2019 - 16:14:37')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Consulte o QR Code pelo aplicativo "De olho na nota",')+#10+ tp.textoCondensado('disponivel na AppStore (Apple) e PlayStore (Android)')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);





          //cmd := tp.printMemory;
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);

          //cmd := tp.desligaModoPagina();
          //WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          cmd := tp.justify(49);
          WritePrinter(HandleImp, @cmd[0], Length(cmd), CaracteresImpressos);
          textoSimples := tp.textoCondensado('---------------------------------------------------------------')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := tp.textoCondensado('Projeto Tanca - www.tanca.com.br');
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);

          ComandoAnsiString :=#10+#10+#10+#10+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

          cmd := tp.cortePapel;
          WritePrinter(HandleImp, cmd, Length(cmd), CaracteresImpressos);
          EndPagePrinter(HandleImp);
          EndDocPrinter(HandleImp);
          ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.Exemplo01();
var
  textoSimples : AnsiString;
  cmd : TBytes;
begin
  justifyTBytes := tp.justify(49);
  ComandoAnsiString := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');

  FuncaoAnsiString := 'Customizada OEI-1';
  DescricaoAnsiString := 'Outros Estilos de Impresso - Bilhete de Festa: ';


  if(limparMemo = true) then
    Memo1.Clear;



  //DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, '');
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandAnsi('ESC ! n', 'Impressao de texto Negrito', tp.textoNegrito('Black Party'));
  DebugCommandAnsi('ESC ! n', 'Impressao de texto Normal', tp.textoNegrito('Data: 01/01/2019'));
  DebugCommandAnsi('GS ( k pL pH cn fn', 'Exemplo QRCode SAT', ComandoAnsiString);
  Memo1.Lines.Add('---------------------------------------------------------------------------------------------------------------------');


  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Write(F,TBytesToAnsiString(tp.justify(49)));
      textoSimples := tp.textoNegrito('Black Party');
      Writeln(F,textoSimples);
      textoSimples := 'Data: 01/01/2019';
      Writeln(F,textoSimples);
      textoSimples := 'Abertura: 21:00h';
      Writeln(F,textoSimples);
      textoSimples := 'Local: Chacara Estrela';
      Writeln(F,textoSimples);
      textoSimples := 'Masculino';
      Writeln(F,textoSimples);
      textoSimples := 'Universitario - R$00.00';
      Writeln(F,textoSimples);
      Write(F,ComandoAnsiString);
      Write(F,FeedPaperCOM);
      Write(F,TBytesToAnsiString(tp.cortePapel));
      CloseFile(F);
      conexao := True;
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
          conexao := False;
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);

          StartPagePrinter(HandleImp);

          WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
          textoSimples := tp.textoNegrito('Black Party')+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Data: 01/01/2019'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Abertura: 21:00h'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Local: Chacara Estrela'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Masculino'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Universitario - R$00.00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Exemplo Bilhete Festa'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);
          FeedPaper();
          cmd := tp.cortePapel;
          WritePrinter(HandleImp, cmd, Length(cmd), CaracteresImpressos);
          EndPagePrinter(HandleImp);
          EndDocPrinter(HandleImp);
          ClosePrinter(HandleImp);


  end;
  end;
end;
procedure TForm1.Exemplo02();
var
  textoSimples : AnsiString;
  cmd : TBytes;
begin
  justifyTBytes := tp.justify(49);
  ComandoAnsiString := tp.qrcode(4, '35141146377222003730599000004630000853254753|201411051'+
                          '34843|637.00||H0iMysWjM9zOXjaxkpPjqk7Q0Fp4RFvWkC0jLngU'+
                          '8o/pg5WpjhiVU2i/7BnIDz/WU3bMd9Cg6qWHvyn11e+qE7VpUjfZFP'+
                          'iczrrxPOqke3kdaX3y2db0/xebRcLUn1+PO2fvKK/7tAPMUiXvb1YD'+
                          'H6DqHVBhoM5A7u3P5RZrHvl1dfaJumLbe5uejKmq4rDNdOI5EVReJ5'+
                          'q1O6asOzwd8O0JzUGIf9aSdcClKWY3Xqt+0IWGjX61Kb8bEobAe4wV'+
                          '69hPpCApoAwDzrjuB110aUa2Q2aR/X3GWgqs8GTNvwQVDYNexuo3Pk'+
                          '67uo/hUr8tLMb2K15SIqoCBfya6sUIvA==');

  FuncaoAnsiString := '-';
  DescricaoAnsiString := 'Outros Estilos de Impresso: ';
  //if(limparMemo = true) then
  //  Memo1.Clear;
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  //DebugCommandAnsi('ESC ! n', 'Impressao de texto Negrito', tp.textoNegrito('Black Party'));
  DebugCommandAnsi('ESC ! n', 'Impressao de texto Normal', tp.textoNegrito('Data 01/01/2019  Hora 18:00  004-001'));

  if(formaEnvio = 0) then
  begin
    if((cbbDriver.Text <> '') and (conexao = True)) then
    begin
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Write(F,TBytesToAnsiString(justifyTBytes));
      textoSimples := 'Data 01/01/2019  Hora 18:00  004-001';
      Writeln(F,textoSimples);
      textoSimples := '-----------------------------------------';
      Writeln(F,textoSimples);
      textoSimples := '*** CUPOM NAO FISCAL ***';
      Writeln(F,textoSimples);
      textoSimples := 'RELATORIO DE FECHAMENTO' + #10;
      Writeln(F,textoSimples);
      textoSimples := 'Operador: 0001';
      Writeln(F,textoSimples);
      textoSimples := 'Abertura: 12:13 Caixa: 004';
      Writeln(F,textoSimples);
      textoSimples := '-----------------------------------------';
      Writeln(F,textoSimples);
      textoSimples := 'RESUMO';
      Writeln(F,textoSimples);
      justifyTBytes := tp.justify(48);
      Write(F,TBytesToAnsiString(justifyTBytes));
      textoSimples := 'Valor Inicial                 :             0,00';
      Writeln(F,textoSimples);
      textoSimples := 'Dinheiro                   (+):           420,00';
      Writeln(F,textoSimples);
      textoSimples := 'Entrada de Caixa           (+):             0,00';
      Writeln(F,textoSimples);
      textoSimples := 'Sangria de Dinheiro        (-):             0,00';
      Writeln(F,textoSimples);
      textoSimples := 'Saida de Caixa             (-):             0,00';
      Writeln(F,textoSimples);
      textoSimples := 'Valor Final                (-):             0,00';
      Writeln(F,textoSimples);
      textoSimples := 'Falta                         :          -420,00' +#10 + #10;
      Writeln(F,textoSimples);
      textoSimples := 'Venda Bruta                   :           420,00';
      Writeln(F,textoSimples);
      textoSimples := 'Venda Liquida                 :           420,00';
      Writeln(F,textoSimples);
      justifyTBytes := tp.justify(49);
      Write(F,TBytesToAnsiString(justifyTBytes));
      textoSimples := '-----------------------------------------';
      Writeln(F,textoSimples);

      textoSimples := 'Data 01/01/2019  Hora 18:00  004-001';
      Write(F,textoSimples);
      Write(F,FeedPaperCOM);
      Write(F,TBytesToAnsiString(tp.cortePapel));
      CloseFile(F);
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);

          StartPagePrinter(HandleImp);

          WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
          textoSimples := 'Data 01/01/2019  Hora 18:00  004-001'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := '-----------------------------------------' +#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := '*** CUPOM NAO FISCAL ***'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'RELATORIO DE FECHAMENTO' + #10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Operador: 0001'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Abertura: 12:13 Caixa: 004'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := '-----------------------------------------'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'RESUMO'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          justifyTBytes := tp.justify(48);
          WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
          textoSimples := 'Valor Inicial                 :             0,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Dinheiro                   (+):           420,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Entrada de Caixa           (+):             0,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Sangria de Dinheiro        (-):             0,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Saida de Caixa             (-):             0,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Valor Final                (-):             0,00' +#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Falta                         :          -420,00' +#10+#10+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Venda Bruta                   :           420,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Venda Liquida                 :           420,00'+#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          justifyTBytes := tp.justify(49);
          WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);

          textoSimples := '-----------------------------------------' +#10;
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);
          textoSimples := 'Data 01/01/2019  Hora 18:00  004-001';
          WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);

          FeedPaper();
          cmd := tp.cortePapel;
          WritePrinter(HandleImp, cmd, Length(cmd), CaracteresImpressos);
          EndPagePrinter(HandleImp);
          EndDocPrinter(HandleImp);
          ClosePrinter(HandleImp);

  end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Exemplo01();
  Exemplo02();
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
      {
      //DebugCommandAnsi('Teste', 'Teste', tp.gravarLogoRasterStr(0,'C:\Users\Julio\Documents\testelogo/logo.bmp',1,10,10));
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,'Teste');
      Writeln(F, tp.gravarLogoRasterStr('C:\Users\Julio\Documents\testelogo/logo.bmp',0,1,10,10));
      Writeln(F,FeedPaperCOM);


      CloseFile(F);}
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  textoSimples : AnsiString;
begin
  justifyTBytes := tp.justify(opJustify);

  FuncaoAnsiString := 'ESC ! n';

  DescricaoAnsiString := 'Impressao de texto Sublinhado';
  ComandoAnsiString := 'Exemplo texto Sublinhado';
  if(limparMemo = true) then
    Memo1.Clear;
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);
  DebugCommandAnsi('ESC - n', 'Ativar modo Sublinhado', tp.modoSublinhado(49));


  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  DebugCommandAnsi('ESC - n', 'Desativar modo Sublinhado', tp.modoSublinhado(48));
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));

      Writeln(F,DescricaoAnsiString);
      Writeln(F,tp.modoSublinhado(49));
      Writeln(F,ComandoAnsiString);
      Writeln(F,tp.modoSublinhado(48));
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  textoSimples := tp.modoSublinhado(49);
  WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);

  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);
  textoSimples := tp.modoSublinhado(48);
  WritePrinter(HandleImp, PAnsiChar(textoSimples), Length(textoSimples), CaracteresImpressos);


  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      //Writeln(F,TBytesToAnsiString(justifyTBytes));
      //Writeln(F,DescricaoAnsiString);
      Writeln(F,tp.modoSublinhado(49));
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
    AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,tp.espacamentoCustom(200));
      Writeln(F,'Teste');
      Writeln(F,'Teste');
      Writeln(F,'Teste');
      Writeln(F,'Teste');
      Writeln(F,'Teste');
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
end;

procedure TForm1.btTextoNegritoClick(Sender: TObject);
begin
  justifyTBytes := tp.justify(opJustify);

  FuncaoAnsiString := 'ESC ! n';
  DescricaoAnsiString := 'Impressao de texto Negrito';
  ComandoAnsiString := tp.textoNegrito('Exemplo texto negrito');
  if(limparMemo = true) then
    Memo1.Clear;
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);

  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';

  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.btTextoNormalClick(Sender: TObject);
begin
  justifyTBytes := tp.justify(opJustify);

  FuncaoAnsiString := 'ESC ! n';

  DescricaoAnsiString := 'Impressao de texto Normal';
  ComandoAnsiString := 'Exemplo texto Normal';
  if(limparMemo = true) then
    Memo1.Clear;
  DebugCommandTBy('ESC a n', 'Seleo de Alinhamento', justifyTBytes);

  DebugCommandAnsi(FuncaoAnsiString, DescricaoAnsiString, ComandoAnsiString);
  if(formaEnvio = 0) then
  begin
    if(cbbDriver.Text <> '') then
    begin
      try
      AssignFile(F,cbbDriver.Text);
      Rewrite(F);

      Writeln(F,TBytesToAnsiString(justifyTBytes));
      Writeln(F,DescricaoAnsiString);
      Writeln(F,ComandoAnsiString);
      Writeln(F,FeedPaperCOM);


      CloseFile(F);
      except on E : EInOutError do
       begin
          ShowMessage('Porta COM incorreta!');
       end;
    end;
    end;

  end
  else
  begin
  if not OpenPrinter(PChar(driverselecionado), HandleImp, nil) then
    Memo1.Lines.Add('Erro: Impressora no encontrada')

  else
  begin
  DescricaoAnsiString := copy(DescricaoAnsiString,0,Length(DescricaoAnsiString))+ #10;
  Documento.pDocName := PChar('Minha impresso');
  Documento.pOutputFile := nil;
  Documento.pDataType := 'RAW';


  StartDocPrinter(HandleImp, 1, @Documento);

  StartPagePrinter(HandleImp);

  WritePrinter(HandleImp, @justifyTBytes[0], Length(justifyTBytes), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(DescricaoAnsiString), Length(DescricaoAnsiString), CaracteresImpressos);
  WritePrinter(HandleImp, PAnsiChar(ComandoAnsiString), Length(ComandoAnsiString), CaracteresImpressos);

  FeedPaper();
  EndPagePrinter(HandleImp);
  EndDocPrinter(HandleImp);
  ClosePrinter(HandleImp);


  end;
  end;

end;

procedure TForm1.cbbDriverSelect(Sender: TObject);
var
  i : integer;
begin
  driverselecionado := cbbDriver.Text;

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if debug then
  begin
    debug:= False;
    Form1.Height := Form1.Height - 20 - Memo1.Height;
    Form1.Width := Form1.Width ;
    Memo1.Anchors := [akLeft, akTop];
    Memo1.Hide;
    CheckBox2.Visible := false;
  end
  else
  begin
    debug:= True;
    Form1.Height := Form1.Height + 20 + Memo1.Height;
    Form1.Width := Form1.Width;
    Memo1.Anchors := [akLeft, akRight, akBottom, akTop];
    Memo1.Clear;
    Memo1.Show;
    CheckBox2.Visible := true;
  end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if(CheckBox2.Checked = true) then
    limparMemo := true
  else
    limparMemo := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 debug:= True;
 fsSendBytesCount    := 0 ;
 limparMemo := true;
  portas := TStringList.Create;
  portas.Add('COM1');
  portas.Add('COM2');
  portas.Add('COM3');
  portas.Add('COM4');
  portas.Add('COM5');
  portas.Add('COM6');
  portas.Add('COM7');
  portas.Add('COM8');
  portas.Add('COM9');
  portas.Add('COM10');
  portas.Add('COM11');
  portas.Add('COM12');
  cbbDriver.Items := portas;
 CheckBox1Click(Sender);



end;

end.
